#!/bin/python
#
# GAMBIT: Global and Modular BSM Inference Tool
#*********************************************
# \file
#
#  FlexibleSUSY Fortran link flag harvester
#  
#  This script simply reads the config/config.h
#  file generated by the flexiblesusy configure
#  script and grabs some flags needed to 
#  properly link to fortran libraries.
#
#*********************************************
#
#  Authors (add name and date if you modify):
#
#  \author Ben Farmer
#          (benjamin.farmer@fysik.su.se)
#    \date 2014 Dec
#
#*********************************************

import os
import sys

def getScriptPath():
    return os.path.dirname(os.path.realpath(sys.argv[0]))

with open("{0}/flexiblesusy/config/config.h".format(getScriptPath())) as f:
  for line in f:
    words = line.split()
    try:
      token = words[1]
    except:
      continue
    if token == "FLIBS":
      string = " ".join(words[2:])
      if string.startswith('"') and string.endswith('"'):
        string = string[1:-1]
      sys.stdout.write(string)
      sys.exit(0) 
sys.exit(1)
